Package net.sf.saxon.expr.sort

## Class SortedIterator

- java.lang.Object
- - net.sf.saxon.expr.sort.SortedIterator

- All Implemented Interfaces:
    `java.io.Closeable`, `java.lang.AutoCloseable`, `LastPositionFinder`, `SequenceIterator`, `LookaheadIterator`
  Direct Known Subclasses:
    `SortedGroupIterator`

      public class SortedIterator
      extends java.lang.Object
      implements SequenceIterator, LastPositionFinder, LookaheadIterator

  Class to do a sorted iteration

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface net.sf.saxon.om.SequenceIterator

      `SequenceIterator.Property`

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected SequenceIterator` | `base` |
    `protected AtomicComparer[]` | `comparators` |
    `protected XPathContext` | `context` |
    `protected int` | `count` |
    `protected int` | `position` |
    `protected SortKeyEvaluator` | `sortKeyEvaluator` |
    `protected ObjectToBeSorted[]` | `values` |

  - ### Constructor Summary

    Constructors
    Modifier | Constructor | Description
    --- | --- | ---
    `protected` | `SortedIterator()` |
    `` | `SortedIterator​(XPathContext context, SequenceIterator base, SortKeyEvaluator sortKeyEvaluator, AtomicComparer[] comparators, boolean createNewContext)` | Create a sorted iterator

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `protected void` | `buildArray()` | Create an array holding the items to be sorted and the values of their sort keys
    `int` | `getLength()` | Get the last position (that is, the number of items in the sequence).
    `java.util.EnumSet<SequenceIterator.Property>` | `getProperties()` | Get properties of this iterator, as a bit-significant integer.
    `boolean` | `hasNext()` | Determine whether there are more items to come.
    `Item` | `next()` | Get the next item, in sorted order
    `void` | `setHostLanguage​(HostLanguage language)` | Set the host language

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.om.SequenceIterator

      `close, forEachOrFail, materialize`

- - ### Field Detail

    - #### base

          protected SequenceIterator base

    - #### sortKeyEvaluator

          protected SortKeyEvaluator sortKeyEvaluator

    - #### comparators

          protected AtomicComparer[] comparators

    - #### values

          protected ObjectToBeSorted[] values

    - #### count

          protected int count

    - #### position

          protected int position

    - #### context

          protected XPathContext context

  - ### Constructor Detail

    - #### SortedIterator

          protected SortedIterator()

    - #### SortedIterator

          public SortedIterator​(XPathContext context,
                                SequenceIterator base,
                                SortKeyEvaluator sortKeyEvaluator,
                                AtomicComparer[] comparators,
                                boolean createNewContext)

      Create a sorted iterator
      Parameters:
        `context` - the dynamic XPath evaluation context
        `base` - an iterator over the sequence to be sorted
        `sortKeyEvaluator` - an object that allows the n'th sort key for a given item to be evaluated
        `comparators` - an array of AtomicComparers, one for each sort key, for comparing sort key values
        `createNewContext` - true if sort keys are computed relative to the item being sorted (as in XSLT but not XQuery)

  - ### Method Detail

    - #### setHostLanguage

          public void setHostLanguage​(HostLanguage language)

      Set the host language
      Parameters:
        `language` - the host language (for example `HostLanguage.XQUERY`)

    - #### hasNext

          public boolean hasNext()

      Determine whether there are more items to come. Note that this operation is stateless and it is not necessary (or usual) to call it before calling next(). It is used only when there is an explicit need to tell if we are at the last element.

      This method must not be called unless the result of getProperties() on the iterator includes the bit setting `SequenceIterator.Property.LOOKAHEAD`

      Specified by:
        `hasNext` in interface `LookaheadIterator`
      Returns:
        true if there are more items in the sequence

    - #### next

          public Item next()
                    throws XPathException

      Get the next item, in sorted order
      Specified by:
        `next` in interface `SequenceIterator`
      Returns:
        the next item, or null if there are no more items. Once a call on next() has returned null, no further calls should be made. The preferred action for an iterator if subsequent calls on next() are made is to return null again, and all implementations within Saxon follow this rule.
      Throws:
        `XPathException` - if an error occurs retrieving the next item

    - #### getLength

          public int getLength()
                        throws XPathException

      Description copied from interface: `LastPositionFinder`
      Get the last position (that is, the number of items in the sequence). This method is non-destructive: it does not change the state of the iterator. The result is undefined if the next() method of the iterator has already returned null. This method must not be called unless the result of getProperties() on the iterator includes the bit setting `SequenceIterator.Property.LAST_POSITION_FINDER`
      Specified by:
        `getLength` in interface `LastPositionFinder`
      Returns:
        the number of items in the sequence
      Throws:
        `XPathException` - if an error occurs evaluating the sequence in order to determine the number of items

    - #### getProperties

          public java.util.EnumSet<SequenceIterator.Property> getProperties()

      Get properties of this iterator, as a bit-significant integer.
      Specified by:
        `getProperties` in interface `SequenceIterator`
      Returns:
        the properties of this iterator. This will be some combination of properties such as `SequenceIterator.Property.GROUNDED`, `SequenceIterator.Property.LAST_POSITION_FINDER`, and `SequenceIterator.Property.LOOKAHEAD`. It is always acceptable to return the value zero, indicating that there are no known special properties. It is acceptable for the properties of the iterator to change depending on its state.

    - #### buildArray

          protected void buildArray()
                             throws XPathException

      Create an array holding the items to be sorted and the values of their sort keys
      Throws:
        `XPathException` - if an error occurs for example in evaluating a sort key